	subroutine kvadrat(s)
	include 'GL/fgl.h'
	character s*(*), c
	integer*4 GLUT_STROKE_TIMES_ROMAN
	parameter (GLUT_STROKE_ROMAN = 1)
	call fglPushMatrix
	call fglTranslatef(0.0, 0.0, 1.0)
	call fglNormal3f(0.0, 0.0, 1.0)
	call fglRectf(-1.0, -1.0, 1.0, 1.0)
	call fglTranslatef(-0.8, 0.0, 0.01)
	call fglDisable(GL_LIGHTING)
	call fglScalef(0.003, 0.003, 0.003)
	call fglColor3f(1.0, 0.0, 0.0)
	call fglRasterpos3f(0.0, 0.0, 0.1)
	lenc = len(s)
	do i=1,lenc
	  c = s(i:i)
	  call fglutBitmapCharacter(6, ichar(c))
	end do
	call fglEnable(GL_LIGHTING)
	call fglPopMatrix
	end

	subroutine display
	implicit none
	include 'GL/fgl.h'
	real material_diffuse(4)
	data material_diffuse /0.9, 0.6, 0.3, 1.0/ 
	call fglClear(GL_COLOR_BUFFER_BIT+GL_DEPTH_BUFFER_BIT)
	call fglPushMatrix
	call fglRotatef(30.0, 1.0, 0.0, 0.0)
	call fglRotatef(30.0, 0.0, 1.0, 0.0)
	call fglScalef(0.5, 0.5, 0.5)
	call fglMaterialfv(GL_FRONT, GL_DIFFUSE, material_diffuse)
	call kvadrat('Spredaj')
	call fglRotatef(90.0, 0.0, 1.0, 0.0)
	call kvadrat('Desno')
	call fglRotatef(90.0, 0.0, 1.0, 0.0)
	call kvadrat('Zadaj')
	call fglRotatef(90.0, 0.0, 1.0, 0.0)
	call kvadrat('Levo')
	call fglRotatef(90.0, 1.0, 0.0, 0.0)
	call kvadrat('Spodaj')
	call fglRotatef(180.0, 1.0, 0.0, 0.0)
	call kvadrat('Zgoraj')
	call fglPopMatrix
	call fglFlush
	end

	subroutine reshape(w, h)
	include 'GL/fgl.h'
	integer w, h
	real*8 l
	l = 1
	call fglViewPort(0, 0, w, h)
	call fglMatrixMode(GL_PROJECTION)
	call fglLoadIdentity
	call fglOrtho(-l,l,-l,l,-l,l)
	call fglMatrixMode(GL_MODELVIEW)
	call fglLoadIdentity
	end

	program crta
	external display
	external reshape
	include 'GL/fglut.h'
	include 'GL/fgl.h'
	call fglutinit
	call fglutinitdisplaymode(GLUT_SINGLE+GLUT_RGB+GLUT_DEPTH)
	call fglutcreatewindow('Fortran GLUT program')
	call fglutDisplayFunc(display)
	call fglutReshapeFunc(reshape)
	call fglEnable(GL_DEPTH_TEST)
	call fglEnable(GL_LIGHTING)
	call fglEnable(GL_LIGHT0)
	call fglClearColor(1.0, 1.0, 1.0, 1.0)
	call fglutmainloop
	end
