C  Copyright (c) Mark J. Kilgard, 1994.

C  This program is freely distributable without licensing fees
C  and is provided without guarantee or warrantee expressed or
C  implied.  This program is -not- in the public domain.

C  GLUT Fortran example demonstrating use of bitmap fonts.


c	GLUT_STROKE_ROMAN               1
c	GLUT_STROKE_MONO_ROMAN          2
c	GLUT_BITMAP_9_BY_15             3
c	GLUT_BITMAP_8_BY_13             4
c	GLUT_BITMAP_TIMES_ROMAN_10      5
c	GLUT_BITMAP_TIMES_ROMAN_24      6
c 	GLUT_BITMAP_HELVETICA_10        7
c	GLUT_BITMAP_HELVETICA_12        8
c	GLUT_BITMAP_HELVETICA_18        9

	subroutine output(x,y,s)
	include 'GL/fgl.h'
	include 'GL/fglut.h'
	real x,y
	character s*(*)
	character c
	integer*4 GLUT_BITMAP_TIMES_ROMAN_24
	parameter (GLUT_BITMAP_TIMES_ROMAN_24 = 1)
	call fglrasterpos2f(x,y)
	lenc = len(s)
	do 10, i=1,lenc
	  c = s(i:i)
	  call fglutBitmapCharacter(GLUT_BITMAP_TIMES_ROMAN_24, ichar(c))
10      continue
	end

	subroutine display
	include 'GL/fgl.h'
	call fglclear(GL_COLOR_BUFFER_BIT)
	call output(0.0,24.0,'This is written in a GLUT bitmap font.')
	call output(100.0,100.0,'ABCDEFGabcdefg')
	call output(50.0,145.0, '(positioned in pixels with upper-left origin)')
	call fglflush
	end

	subroutine reshape(w,h)
	integer w, h
	include 'GL/fgl.h'
	include 'GL/fglu.h'
	call fglviewport(0, 0, w, h)
	call fglmatrixmode(GL_PROJECTION)
	call fglloadidentity
	call fgluortho2d(dble(0.0), dble(w), dble(0.0), dble(h))
	call fglscalef(1.0, -1.0, 1.0)
	call fgltranslatef(real(0.0), real(-h), real(0.0))
	call fglmatrixmode(GL_MODELVIEW)
	end

	program main
	include 'GL/fglut.h'
	include 'GL/fgl.h'
	external display
	external reshape
	integer win
	call fglutinitdisplaymode(GLUT_RGB + GLUT_SINGLE)
	call fglutinitwindowsize(500, 150)
	call fglutinit
	win = fglutcreatewindow('Fortran GLUT bitmap A')
	call fglclearcolor(0.0, 0.0, 0.0, 1.0)
	call fglutdisplayfunc(display)
	call fglutreshapefunc(reshape)
	call fglutmainloop
	end

