	subroutine redraw
	implicit none
	include 'GL/fgl.h'
	common /vertices/ n, vertex(2, 100)
	integer n, i
	real vertex
	call fglClear(GL_COLOR_BUFFER_BIT)
	call fglbegin(GL_LINE_STRIP)
	do i = 1,n
		call fglVertex2f(vertex(1, i), vertex(2, i))
	end do
	call fglend
	call fglFlush
	end
	
	subroutine mouse (button, state, x, y) 
	implicit none
	include 'GL/fglut.h'
	include 'GL/fgl.h'
	include 'GL/fglu.h'
	common /vertices/ n, vertex(2, 100)
	integer n, i
	real vertex
	integer button, state, x, y
	integer viewport(4)
	real*8 mvmatrix(16), projmatrix(16)
	real*8 wx, wy, wz               ! returned world x, y, z coords
	real*8 px, py, pz       	! picked window coortinates
	integer status

	if (button .eq. GLUT_LEFT_BUTTON) then
	 if (state .eq. GLUT_DOWN) then
		call fglGetIntegerv (GL_VIEWPORT, viewport)
		call fglGetDoublev (GL_MODELVIEW_MATRIX, mvmatrix)
	    	call fglGetDoublev (GL_PROJECTION_MATRIX, projmatrix)
c               note viewport(4) is height of window in pixels 
		px = x
		py = viewport(4) -  y - 1
		pz = 0.0
		print *, ' Coordinates at cursor are ', px, py
	     	status = fgluUnProject (px, py, pz,  mvmatrix, 
     1                      projmatrix,  viewport, wx, wy, wz)
	     	print *, 'World coords at z=0.0 are ', wx, wy, wz
		n = n + 1
		vertex(1, n) = wx
		vertex(2, n) = wy
		call fglutPostRedisplay
	 end if
       	end if
	end


	program main
	external redraw
	external mouse
	include 'GL/fglut.h'
	call fglutinit
	call fglutinitdisplaymode(ior(GLUT_SINGLE,GLUT_RGB))
	call fglutInitWindowSize (500, 500)
	call fglutInitWindowPosition (100, 100)
	window = fglutcreatewindow('Click in window')
	call fglutdisplayfunc(redraw)
	call fglutMouseFunc(mouse)
	call fglutmainloop
	end
